# coding: utf-8

"""
    ChannelEngine Merchant API

    ChannelEngine API for merchants  # noqa: E501

    The version of the OpenAPI document: 2.9.10
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from channelengine_merchant_api_client.configuration import Configuration


class MerchantReturnLineUpdateRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'merchant_product_no': 'str',
        'accepted_quantity': 'int',
        'rejected_quantity': 'int'
    }

    attribute_map = {
        'merchant_product_no': 'MerchantProductNo',
        'accepted_quantity': 'AcceptedQuantity',
        'rejected_quantity': 'RejectedQuantity'
    }

    def __init__(self, merchant_product_no=None, accepted_quantity=None, rejected_quantity=None, local_vars_configuration=None):  # noqa: E501
        """MerchantReturnLineUpdateRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._merchant_product_no = None
        self._accepted_quantity = None
        self._rejected_quantity = None
        self.discriminator = None

        self.merchant_product_no = merchant_product_no
        self.accepted_quantity = accepted_quantity
        self.rejected_quantity = rejected_quantity

    @property
    def merchant_product_no(self):
        """Gets the merchant_product_no of this MerchantReturnLineUpdateRequest.  # noqa: E501

        The unique product reference used by the Merchant (sku).  # noqa: E501

        :return: The merchant_product_no of this MerchantReturnLineUpdateRequest.  # noqa: E501
        :rtype: str
        """
        return self._merchant_product_no

    @merchant_product_no.setter
    def merchant_product_no(self, merchant_product_no):
        """Sets the merchant_product_no of this MerchantReturnLineUpdateRequest.

        The unique product reference used by the Merchant (sku).  # noqa: E501

        :param merchant_product_no: The merchant_product_no of this MerchantReturnLineUpdateRequest.  # noqa: E501
        :type merchant_product_no: str
        """
        if self.local_vars_configuration.client_side_validation and merchant_product_no is None:  # noqa: E501
            raise ValueError("Invalid value for `merchant_product_no`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                merchant_product_no is not None and len(merchant_product_no) > 64):
            raise ValueError("Invalid value for `merchant_product_no`, length must be less than or equal to `64`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                merchant_product_no is not None and len(merchant_product_no) < 0):
            raise ValueError("Invalid value for `merchant_product_no`, length must be greater than or equal to `0`")  # noqa: E501

        self._merchant_product_no = merchant_product_no

    @property
    def accepted_quantity(self):
        """Gets the accepted_quantity of this MerchantReturnLineUpdateRequest.  # noqa: E501

        The amount of items that have been accepted.  # noqa: E501

        :return: The accepted_quantity of this MerchantReturnLineUpdateRequest.  # noqa: E501
        :rtype: int
        """
        return self._accepted_quantity

    @accepted_quantity.setter
    def accepted_quantity(self, accepted_quantity):
        """Sets the accepted_quantity of this MerchantReturnLineUpdateRequest.

        The amount of items that have been accepted.  # noqa: E501

        :param accepted_quantity: The accepted_quantity of this MerchantReturnLineUpdateRequest.  # noqa: E501
        :type accepted_quantity: int
        """
        if self.local_vars_configuration.client_side_validation and accepted_quantity is None:  # noqa: E501
            raise ValueError("Invalid value for `accepted_quantity`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                accepted_quantity is not None and accepted_quantity < 0):  # noqa: E501
            raise ValueError("Invalid value for `accepted_quantity`, must be a value greater than or equal to `0`")  # noqa: E501

        self._accepted_quantity = accepted_quantity

    @property
    def rejected_quantity(self):
        """Gets the rejected_quantity of this MerchantReturnLineUpdateRequest.  # noqa: E501

        The amount of items that have been rejected.  # noqa: E501

        :return: The rejected_quantity of this MerchantReturnLineUpdateRequest.  # noqa: E501
        :rtype: int
        """
        return self._rejected_quantity

    @rejected_quantity.setter
    def rejected_quantity(self, rejected_quantity):
        """Sets the rejected_quantity of this MerchantReturnLineUpdateRequest.

        The amount of items that have been rejected.  # noqa: E501

        :param rejected_quantity: The rejected_quantity of this MerchantReturnLineUpdateRequest.  # noqa: E501
        :type rejected_quantity: int
        """
        if self.local_vars_configuration.client_side_validation and rejected_quantity is None:  # noqa: E501
            raise ValueError("Invalid value for `rejected_quantity`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                rejected_quantity is not None and rejected_quantity < 0):  # noqa: E501
            raise ValueError("Invalid value for `rejected_quantity`, must be a value greater than or equal to `0`")  # noqa: E501

        self._rejected_quantity = rejected_quantity

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MerchantReturnLineUpdateRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MerchantReturnLineUpdateRequest):
            return True

        return self.to_dict() != other.to_dict()
